; KEENFIX.ASM - VGA mode 0xD retrace\LCD color corruption fix TSR v.0.1
; mainly for Commander Keen series games :)
; coded in about one hour by Artem Vasilev - wbc \\ b-state 18.12.2o15
; tested with Matrox Millennium, maybe works with other Matrox cards
; also Voodoo Banshee\3\4\5 and Intel i740 users - try it! :)

; USE AT OWN RISK - UTILIZES NON-STANDARD CRTC PARAMETERS!!1!
; currently still have some issues with Catacomb 3D (screen shifts up)

; use FASM to compile

format binary
org 100h

start:
                jmp     init

int10:
int10ofs        dw      ?
int10seg        dw      ?

newint10id      dw      "S3"                  ; our signature :)
newint10:
                cmp     ax, 0000Dh            
                jne     @call
                
                pushf
                push    cs
                push    boost
@call:
                jmp     dword [cs:int10]
boost:                                        
                pusha
                mov     dx, 3D4h
                mov     al, 11h
                out     dx, al
                inc     dx
                in      al, dx
                and     al, 7Fh
                out     dx, al                ; unlock cr0 - cr7
                dec     dx
                
                mov     ax, 09005h            ; horizontal retrace end
                out     dx, ax
                
                ; if you want to completely kill border uncomment this
                ; it can help if screen shifts down or shrinks horizontally
                ; may be incompatible with some videocards\monitors!
                
                ;mov     ax, 02702h            ; horizontal blank start
                ;out     dx, ax
                ;mov     ax, 0BF16h            ; vertical   blank end
                ;out     dx, ax
                
                popa
                iret
       
newint10end:
init:
                mov     ax, cs
                mov     ds, ax
                
                mov     ah, 9
                mov     dx, infostr
                int     21h                   ; display our message
                
                mov     ax, 3510h
                int     21h                   ; get int10h vector
                
                cmp     word [es:bx-2], "S3"  ; check for signature
                jnz     install
release:                                      ; remove us
                mov     ah, 9
                mov     dx, released_str
                int     21h 
                
                mov     ax, [es:int10seg]
                mov     ds, ax
                mov     dx, [es:int10ofs]
                mov     ax, 2510h
                int     21h                    ; set old int10h
                
                ; now we should release memory, okay? :)
                
                mov     ah, 49h
                int     21h
                
                ret                            ; and now we can exit (yes!)
                
install:
                mov     [int10seg], es
                mov     [int10ofs], bx
                mov     ax, 2510h
                mov     dx, newint10
                int     21h
                
                mov     bx, [cs:2Ch]
                mov     es, bx
                mov     ah, 49h
                int     21h                    ; free environment
                
                mov     ah, 9
                mov     dx, installed_str
                int     21h 
                
                mov     dx, newint10end
                int     27h
                
infostr         db      "VGA mode 0xD retrace fix by wbc\\bz7 18.12.2o15 - $"
installed_str   db      "installed$"
released_str    db      "released$"
